local orig_reload_speed_mul = NewRaycastWeaponBase.reload_speed_multiplier
function NewRaycastWeaponBase:reload_speed_multiplier(...)
	local bonus_mul = 0
	local pm = managers.player
	
	if pm:has_category_upgrade("player","junkie_syringe_reload_speed_bonus") and pm:has_active_temporary_property("junkie_injector_active") then 
		bonus_mul = pm:upgrade_value("player","junkie_syringe_reload_speed_bonus",0)
	end
	
	if pm:has_category_upgrade("player","junkie_syringe_panic_stacks") then 
		local panic_upgrade_data = pm:upgrade_value("player","junkie_syringe_panic_stacks")
		local bonus_per_stack = panic_upgrade_data.reload_speed_bonus
		local panic_stacks = pm:get_property("junkie_panic_stacks",0)
		local panic_bonus = bonus_per_stack * panic_stacks
		bonus_mul = bonus_mul + panic_bonus
	end
	return (orig_reload_speed_mul(self,...) or 1) + bonus_mul
end

local orig_fire_rate_mul = NewRaycastWeaponBase.fire_rate_multiplier
function NewRaycastWeaponBase:fire_rate_multiplier(...)
	local bonus_mul = 0
	local pm = managers.player
	
	if pm:has_category_upgrade("player","junkie_syringe_panic_stacks") then 
		local panic_upgrade_data = pm:upgrade_value("player","junkie_syringe_panic_stacks")
		local bonus_per_stack = panic_upgrade_data.fire_rate_bonus
		local panic_stacks = pm:get_property("junkie_panic_stacks",0)
		local panic_bonus = bonus_per_stack * panic_stacks
		bonus_mul = bonus_mul + panic_bonus
	end

	return (orig_fire_rate_mul(self,...) or 1) + bonus_mul
end