PlayerAction.JunkieInjector = {
	Priority = 1,
	Function = function()
		local pm = managers.player
		local base_upgrade_data = pm:upgrade_value("player","junkie_syringe_base")
		local timer = TimerManager:game()
		local player = pm:local_player()
		if not alive(player) then 
			return
		end
		
		local dmg_ext = player:character_damage()
		
		local start_time = timer:time()
		local base_duration = base_upgrade_data.duration
		local end_time = start_time + base_duration
		
		local function update_ability_radial()
			local time_left = end_time - timer:time()
			managers.hud:activate_teammate_ability_radial(HUDManager.PLAYER_PANEL, time_left, base_duration)
		end
		
		local function add_to_temporary_property_capped(id,duration_add)
			local prop = pm._temporary_properties._properties[id]
			if prop then 
				prop[2] = prop[2] + duration_add
				--something about this isn't consistent with extending the actual coroutine timer
				--but it is overestimating, so i can work around it by removing the temporary property at the coroutine end anyway
			else
				pm:activate_temporary_property(id,duration_add,true)
			end
		end
		
		local function extend_junkie_duration(n)
			
			--[[
			local current_time = timer:time()
			local uncapped_end_time = end_time + n
			local time_remaining = uncapped_end_time - current_time
			time_remaining = math.min(base_duration,time_remaining)
			end_time = end_time + time_remaining
			add_to_temporary_property_capped("junkie_injector_active",time_remaining)
			--]]
			local current_time = timer:time()
			local new_end_time = math.min(end_time + n,current_time + base_duration)
			local time_remaining = new_end_time - current_time
			end_time = new_end_time
			add_to_temporary_property_capped("junkie_injector_active",time_remaining)
			update_ability_radial()
		end
		
		local duration_extension = pm:upgrade_value("player","junkie_syringe_kill_extension",false)
		
		local has_kill_regen = pm:has_category_upgrade("player","junkie_syringe_panic_kill_health_regen")
		local kill_regen_amount,kill_regen_cooldown
		if has_kill_regen then 
			local kill_regen_upgrade_data = pm:upgrade_value("player","junkie_syringe_panic_kill_health_regen")
			
			kill_regen_amount = kill_regen_upgrade_data.health_regen
			kill_regen_cooldown = kill_regen_upgrade_data.cooldown
			
		end
		
		local stamina_regen,stamina_regen_cooldown
		if pm:has_category_upgrade("player","junkie_syringe_stamina_on_kill") then
			local stamina_regen_upgrade_data = pm:upgrade_value("player","junkie_syringe_stamina_on_kill")
			stamina_regen = stamina_regen_upgrade_data.stamina_restored
			stamina_regen_cooldown = stamina_regen_upgrade_data.cooldown
		end
		
		local has_panic_stack = pm:has_category_upgrade("player","junkie_syringe_panic_stacks")
		local panic_stacks_per_kill,panic_stacks_max --,panic_fire_rate_bonus,panic_reload_speed_bonus
		if has_panic_stack then 
			local panic_upgrade_data = pm:upgrade_value("player","junkie_syringe_panic_stacks")
			panic_stacks_per_kill = panic_upgrade_data.stacks_per_kill
			panic_stacks_max = panic_upgrade_data.max_stacks
--			panic_fire_rate_bonus = panic_upgrade_data.fire_rate_bonus
--			panic_reload_speed_bonus = panic_upgrade_data.reload_speed_bonus
		end
		
		--active tag for external effects
		pm:activate_temporary_property("junkie_injector_active",base_duration,true)
		
		
		--movement speed bonus
		--reload speed bonus
		--add kill-cooldown listener
		--add kill-stamina listener
		--add "is in injector" state property
		--add kill-stack listener
		--add reload/firerate temp property check
		--add melee kill-health regen listener + 5s cooldown
		
		
		local on_kill_listener_key = "junkie_injector_active_on_enemy_killed"
		if duration_extension or has_kill_regen or has_panic_stack or stamina_regen then 
			pm:register_message(Message.OnEnemyKilled,on_kill_listener_key,
				function(equipped_unit,variant,killed_unit)
					if alive(player) then
						if has_panic_stack then 
							local panic_stacks = pm:get_property("junkie_panic_stacks",0)
							panic_stacks = math.min(panic_stacks + panic_stacks_per_kill,panic_stacks_max)
							pm:set_property("junkie_panic_stacks",panic_stacks)
							
							if has_kill_regen and not pm:has_active_temporary_property("junkie_kill_regen_cooldown") then 
								dmg_ext:restore_health(kill_regen_amount * panic_stacks,false,true)
								pm:activate_temporary_property("junkie_kill_regen_cooldown",kill_regen_cooldown,true)
							end
						end
						
						
						if duration_extension then
							extend_junkie_duration(duration_extension)
						end
						
						if stamina_regen and not pm:has_active_temporary_property("junkie_stamina_cooldown") then 
							player:movement():add_stamina(stamina_regen)
							pm:activate_temporary_property("junkie_stamina_cooldown",stamina_regen_cooldown,true)
						end
						
					end
				end
			)
		end
		
		update_ability_radial()
		while alive(player) and timer:time() < end_time do 
			coroutine.yield()
		end
		
		managers.hud:set_teammate_ability_radial(HUDManager.PLAYER_PANEL, {current=0,total=1})
		
		pm:unregister_message(Message.OnEnemyKilled, on_kill_listener_key)
		
		pm:set_property("junkie_panic_stacks",0)
		pm:activate_temporary_property("junkie_injector_active",0,false)
		--don't allow the next syringe coroutine to proc unless it's off cooldown
		while not pm:got_max_grenades() do 
			coroutine.yield()
		end
	end
}