
local mvec3_dis_sq = mvector3.distance_sq
local mvec3_set = mvector3.set
local mvec3_set_z = mvector3.set_z
local mvec3_sub = mvector3.subtract
local mvec3_add = mvector3.add
local mvec3_mul = mvector3.multiply
local mvec3_norm = mvector3.normalize

local temp_vec1 = Vector3()

local tmp_ground_from_vec = Vector3()
local tmp_ground_to_vec = Vector3()
local up_offset_vec = math.UP * 30
local down_offset_vec = math.UP * -40


local win32 = SystemInfo:platform() == Idstring("WIN32")


local mvec_pos_new = Vector3()
local mvec_achieved_walk_vel = Vector3()
local mvec_move_dir_normalized = Vector3()



local melee_vars = {
	"player_melee",
	"player_melee_var2"
}

local orig_get_move_speed = PlayerStandard._get_max_walk_speed
function PlayerStandard:_get_max_walk_speed(t, force_run,...)
	if not managers.player:has_category_upgrade("player","junkie_syringe_movement_speed_bonus") then 
		return orig_get_move_speed(self,t,force_run,...)
	end


	local speed_tweak = self._tweak_data.movement.speed
	local movement_speed = speed_tweak.STANDARD_MAX
	local speed_state = "walk"

	if self._state_data.in_steelsight and not managers.player:has_category_upgrade("player", "steelsight_normal_movement_speed") and not _G.IS_VR then
		movement_speed = speed_tweak.STEELSIGHT_MAX
		speed_state = "steelsight"
	elseif self:on_ladder() then
		movement_speed = speed_tweak.CLIMBING_MAX
		speed_state = "climb"
	elseif self._state_data.ducking then
		movement_speed = speed_tweak.CROUCHING_MAX
		speed_state = "crouch"
	elseif self._state_data.in_air then
		movement_speed = speed_tweak.INAIR_MAX
		speed_state = nil
	elseif self._running or force_run then
		movement_speed = speed_tweak.RUNNING_MAX
		speed_state = "run"
	end

	movement_speed = managers.modifiers:modify_value("PlayerStandard:GetMaxWalkSpeed", movement_speed, self._state_data, speed_tweak)
	local morale_boost_bonus = self._ext_movement:morale_boost()
	local multiplier = managers.player:movement_speed_multiplier(speed_state, speed_state and morale_boost_bonus and morale_boost_bonus.move_speed_bonus, nil, self._ext_damage:health_ratio())
	multiplier = multiplier * (self._tweak_data.movement.multiplier[speed_state] or 1)
	local apply_weapon_penalty = true

	if self:_is_meleeing() then
		local melee_entry = managers.blackmarket:equipped_melee_weapon()
		apply_weapon_penalty = not tweak_data.blackmarket.melee_weapons[melee_entry].stats.remove_weapon_movement_penalty
	end

	if alive(self._equipped_unit) and apply_weapon_penalty then
		multiplier = multiplier * self._equipped_unit:base():movement_penalty()
	end

	if managers.player:has_activate_temporary_upgrade("temporary", "increased_movement_speed") then
		multiplier = multiplier * managers.player:temporary_upgrade_value("temporary", "increased_movement_speed", 1)
	end

	if managers.player:has_activate_temporary_upgrade("temporary", "copr_ability") then
		local out_of_health = self._unit:character_damage():health_ratio() + 0.01 < managers.player:upgrade_value("player", "copr_static_damage_ratio", 0)

		if out_of_health then
			multiplier = multiplier * managers.player:upgrade_value("player", "copr_out_of_health_move_slow", 1)
		end
	end

	local junkie_mul = 1
	if managers.player:has_active_temporary_property("junkie_injector_active") then 
		junkie_mul = managers.player:upgrade_value("player","junkie_syringe_movement_speed_bonus",1)
	end
	
	local final_speed = movement_speed * multiplier * junkie_mul
	self._cached_final_speed = self._cached_final_speed or 0

	if final_speed ~= self._cached_final_speed then
		self._cached_final_speed = final_speed

		self._ext_network:send("action_change_speed", final_speed)
	end
	
	
	return final_speed
end

Hooks:PostHook(PlayerStandard,"_do_action_melee","junkie_postadjust_melee_timers",function(self,t,input,skip_damage)
	if managers.player:has_active_temporary_property("junkie_injector_active") then
		if not skip_damage and managers.player:has_category_upgrade("melee","junkie_expire_t_mul") then 
			if self._state_data.melee_expire_t then 
				local melee_mul = managers.player:upgrade_value("melee","junkie_expire_t_mul",1)
				
				local melee_entry = managers.blackmarket:equipped_melee_weapon()
				local td = tweak_data.blackmarket.melee_weapons[melee_entry]
				
				local expire_t_base = td.expire_t
				local repeat_expire_t_base = td.repeat_expire_t
				
				local expire_t = expire_t_base * melee_mul
				local repeat_expire_t = repeat_expire_t_base * melee_mul
				
				self._state_data.melee_expire_t = t + expire_t
				self._state_data.melee_repeat_expire_t = t + repeat_expire_t
			end
		end
	end
end)
